# SPDX-License-Identifier: GPL-2.0-only or BSD-2-Clause
%YAML 1.2
---
$id: http://devicetree.org/schemas/usb/cypress,hx3.yaml#
$schema: http://devicetree.org/meta-schemas/core.yaml#

title: Cypress HX3 USB 3.0 hub controller family

maintainers:
  - Benjamin Bara <benjamin.bara@skidata.com>

allOf:
  - $ref: usb-device.yaml#

properties:
  compatible:
    enum:
      - usb4b4,6504
      - usb4b4,6506

  reg: true

  reset-gpios:
    items:
      - description: GPIO specifier for RESETN pin.

  vdd-supply:
    description:
      1V2 power supply (VDD_EFUSE, AVDD12, DVDD12).

  vdd2-supply:
    description:
      3V3 power supply (AVDD33, VDD_IO).

  peer-hub:
    $ref: /schemas/types.yaml#/definitions/phandle
    description:
      phandle to the peer hub on the controller.

required:
  - compatible
  - reg
  - peer-hub
  - vdd-supply
  - vdd2-supply

additionalProperties: false

examples:
  - |
    #include <dt-bindings/gpio/gpio.h>

    usb {
        dr_mode = "host";
        #address-cells = <1>;
        #size-cells = <0>;

        /* 2.0 hub on port 1 */
        hub_2_0: hub@1 {
          compatible = "usb4b4,6504";
          reg = <1>;
          peer-hub = <&hub_3_0>;
          reset-gpios = <&gpio1 11 GPIO_ACTIVE_LOW>;
          vdd-supply = <&reg_1v2_usb>;
          vdd2-supply = <&reg_3v3_usb>;
        };

        /* 3.0 hub on port 2 */
        hub_3_0: hub@2 {
          compatible = "usb4b4,6506";
          reg = <2>;
          peer-hub = <&hub_2_0>;
          reset-gpios = <&gpio1 11 GPIO_ACTIVE_LOW>;
          vdd-supply = <&reg_1v2_usb>;
          vdd2-supply = <&reg_3v3_usb>;
        };
    };
